// component/selectCoupon/selectCoupon.js
const wxService = require('../../utils/wxService')
const app = getApp()

Component({
  /**
   * 组件的属性列表
   */
  properties: {
    show: { // 显示标识
      type: Boolean,
      value: false
    },
    couponList: {
      type: Array,
      value: []
    }
  },
  /**
   * 组件的初始数据
   */
  data: {
    checkedColor: app.globalData.themeColor,
    isSelect: false,
    newConponOrderList: []
  },
  observers: {
    couponList: function (rate) {
      this.changeList()
    },
  },

  /**
   * 组件的方法列表
   */
  methods: {
    changeList() {
      const { couponList } = this.data
      if (couponList.length) {
        couponList.map(coupon => {
          //处理coupon.couponDTOS有的时候
          if(coupon.couponDTOS){
            coupon.couponDTOS.forEach(item => {
              item.checked = false
              couponList[0].couponDTOS[0] ? couponList[0].couponDTOS[0].checked = true : item[0].checked = true
              item.couponDiscount = coupon.couponDiscount
              item.title = coupon.couponSettingDTO.title
              item.type = coupon.couponSettingDTO.type
              item.faceAmount = coupon.couponSettingDTO.faceAmount
              item.takeCouponBgimg = coupon.couponSettingDetailDTO.style.takeCouponBgimg
              // notice 格式
              item.newNotice = item && item.notice ? JSON.parse(item.notice) : ''
              for (let i in item.newNotice) {
                if (item.newNotice[i].type == 1) {
                  item.newNotice[i].value = item.startTime.substring(0, 10) + ' 至 ' + item.endTime.substring(0, 10)
                }
              }
            });
          }
          else{
            coupon.couponDTOS = [];
            coupon.newNotice = coupon.notice ? JSON.parse(coupon.notice) : ''
            for (let i in coupon.newNotice) {
              if (coupon.newNotice[i].type == 1) {
                coupon.newNotice[i].value = coupon.startTime.substring(0, 10) + ' 至 ' + coupon.endTime.substring(0, 10)
              }
            }
            let obj = {
              id : coupon.cardNo,
              checked : false,
              couponDiscount : coupon.couponDiscount,
              title : coupon.title,
              takeCouponBgimg :coupon.takeCouponBgimg,
              newNotice : coupon.newNotice,
            }
            coupon.couponDTOS = [obj];
          }
        });

        wxService.nextTick(() => {
          this.setData({
            newConponOrderList: couponList
          })
        })
      }
    },
    _updateData(data) {
      if (data) {
        this.setData(data)
      }
    },
    selectCoupon(e) {
      // 1 抵用券  2 折扣券 
      const { id, index, sid, checked, type, amount, couponDiscount} = e.currentTarget.dataset
      const { newConponOrderList } = this.data

      newConponOrderList.forEach(item => {
        // item.couponDTOS.forEach(coupon => coupon.checked = coupon.id == id ? true : false )
        item.couponDTOS.forEach(coupon => {
            if(coupon.checked) {
              coupon.checked =  coupon.checked ? false : true
            } else {
             if(coupon.id) {
              coupon.checked = coupon.id == id ? true : false 
             } else if(coupon.couponSettingId) {
              coupon.checked = coupon.couponSettingId == sid ? true : false 
             } 
            }
        } )
      })

      let params = null
      if(!checked) {
        params = {
          type,
          id,
          sid,
          faceAmount: amount,
          couponDiscount: couponDiscount
        }
      }

      wxService.nextTick(() => {
        this.triggerEvent('updateCoupon', params)
      })

      this.setData({
        newConponOrderList
      }, () => {
        this.hidePopup();
      })
    },
    hidePopup: function () { // 隐藏弹出框
      this.setData({
        show: false
      })
    },
  }
})
