// share/share.js
const wxService = require('../../../../utils/wxService')
const utils = require('../../../../utils/util')
const envInfo = require('../../../../config/index').envInfo
const app = getApp()


wxService.page({
    data: {
        storeId: undefined,
        storeName: undefined,
        shoppingGuidName: undefined,
        latitude: undefined,
        longitude: undefined,
        contactPhone: undefined
    },

    onLoad: function (options) {
        const userInfo = wx.getStorageSync('_baseUserInfo');
        this.getUserInfo(userInfo.member.id);
    },

    locationClick() {
        wx.openLocation({
            latitude: this.data.latitude,
            longitude: this.data.longitude,
            name : this.data.storeName,
            address : this.data.address,
            scale: 18
        })
    },

    getUserInfo(id) {
        wxService.post(`/member/find`, {
            memberId: id
        }).then(res => {
            let member = res.data.data.member;
            this.setData({
                storeId: member.storeId,
                storeName: member.storeName,
                shoppingGuidName: member.shoppingGuidName
            })
            this.getStoreInfo(member.storeId)
        })
    },

    getStoreInfo(id) {
        wxService.get(`/platform/securityB/organization/findById/` + id).then(res => {
            let data = res.data.data ? res.data.data : {}
            this.setData({
                latitude: data.latitude,
                longitude: data.longitude,
                contactPhone: data.contactPhone,
                address: data.addressArea+data.addressDetail
            })
        })
    }

});