// subPackage/page/pages/valueCardInfo/valueCardInfo.js
const app = getApp();
const wxService = require('../../../../utils/wxService')
const utils = require('../../../../utils/util')
wxService.page({

  /**
   * 页面的初始数据
   */
  data: {
    id: null,
    checked: false,
    showModal: false,
    valueCardInfo: {},
    userHasBaseInfo: false
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.data.id = options.id;
    console.log(options)
    // wx.hideShareMenu();
    this.getValueCardActivityInfo();
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    this.userHasLogin();
  },

  //获取当前用户是否登录
  userHasLogin() {
    const baseUserInfo = wx.getStorageSync('_baseUserInfo');
    if (baseUserInfo) {
      this.setData({
        userHasBaseInfo: true
      })
    }
    else {
      this.setData({
        userHasBaseInfo: false
      })
    }
  },
  
  //获取活动详情
  getValueCardActivityInfo() {
    wx.showLoading({
      title: '加载中..',
    });

    wxService.post(`/coupon/couponMoneyBuyActivity/getDetail?id=${this.data.id}`,{},null,true).then(res => {
      if (res) {
        let obj = res.data.data ? res.data.data : null;
        if (obj) {
          obj.activityDesc = obj.definition ? JSON.parse(obj.definition) : [];
          obj.acPayMoney = parseFloat(obj.buyPrice / 10 / 10).toFixed(2);

          obj.startTime = obj.startTime.substring(0, 10);
          obj.endTime = obj.endTime.substring(0, 10);

          obj.hasDate = obj.activityDesc.filter(item => item.type == 1).length > 0;
          //处理说明文本
          let descArr = JSON.parse(JSON.stringify(obj.activityDesc));
          descArr = descArr.filter(item => item.type != 1);
          // let tempArr = descArr.map(item => {
          //   return item.value;
          // });
          // console.log(obj)

          obj.descArr = descArr;
          this.data.valueCardInfo = obj;
          this.setData({
            valueCardInfo: this.data.valueCardInfo
          });
        }
      }
      wx.hideLoading();
    });
  },

  //修改选中状态
  onTapSwitchChecked() {
    this.data.checked = !this.data.checked;
    this.setData({
      checked: this.data.checked
    });
  },
  //关闭modal
  onTapCloseModal() {
    this.setData({
      showModal: false,
    });
  },
  //查看rule
  onTapViewRule() {
    this.setData({
      showModal: true
    })
  },
  //同意并阅读
  onTapModalAgree() {
    this.setData({
      showModal: false,
      checked: true,
    });
  },
  //立即购买
  onTapBuy() {
    if (!this.data.checked) {
      return;
    }

    const { member } = wx.getStorageSync('_baseUserInfo');
    if (!member) {
      wx.showToast({
        title: '请先去登录',
        icon: 'none'
      })
      return;
    }

    if(!member.cardNoWeixin){
      wx.showToast({
        title: '请先开卡后购买',
      });
      
      wxService.openCard()
      return ;
    }
    //buyWayType 1微信 2支付宝
    let memeberId = member.id ,buyWayType = 1;
    let activityId = this.data.id;
    let url = `/coupon/couponMoneyBuyActivity/buyer/buy?activityId=${activityId}&memberId=${memeberId}&buyWayType=${buyWayType}`;

    wx.showLoading({
      title: '支付中..',
    });

    wxService.post(url).then(res => {
      wx.hideLoading();
      if (res.data.result == 0) {
        console.log(res)
        this.setData({
          checked: false,
        });
        let data = res.data.data ? res.data.data : null;
        if (data) {
          let wxParams = data.wxParams;
          wx.requestPayment({
            timeStamp: wxParams.timeStamp,
            nonceStr: wxParams.nonceStr,
            package: wxParams.package,
            signType: wxParams.signType,
            paySign: wxParams.paySign,
            success: res => {
              wx.showModal({
                title: '购买成功提示',
                content: '购买成功，是否到我的优惠券中查看？',
                showCancel: true,
                cancelText: '取消',
                confirmText: '确认',
                confirmColor: app.globalData.themeColor,
                success: function (modalRes) {
                  if (modalRes.confirm) {
                    wx.navigateTo({
                      url: '/pages/coupons/coupons',
                    });
                  }
                }
              });
            },
            fail: error => {
              wx.showToast({
                title: '已取消支付',
                icon: 'none'
              });
            }
          })
        }
      }
      else {
        wx.showToast({
          title: '购买失败，请稍后再试！',
          icon: 'none'
        });
      }
    });
  },
  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

})